(* Copyright 2006, 2008 Andrew W. Appel, Robert Dockins and Xavier Leroy
 * This file is part of the List-machine Benchmark.
 * The List-machine Benchmark is licensed under GPLv3; see LICENSE.
 *)

Add LoadPath "logic".

Require Import ModelSpec.
Require Import Worlds.
Require Import Logic.
Require Import Modal.
Require Import Tactics.
Require Import GoedelLoeb.
Require Import Fields.
Require Import Adjectives. 
Require Import Safety.


Module ModalModel (W':WORLDS) (WS':WORLD_STEP with Module W:=W') :
  MODAL_MODEL
    with Module W:=W'
    with Module WS:=WS'.

  Module PSThy := ProgramSafetyTheory W' WS'.
  Module AThy  := PSThy.AT.
  Module FThy  := AThy.FT.
  Module GLThy := FThy.GL.
  Module Tac   := GLThy.Tac.
  Module MThy  := Tac.MT.
  Module LThy  := MThy.LT.
  Module WThy  := LThy.WT.
  Module WS    := WS'.
  Module W     := W'.
End ModalModel.
